%global pkgver 2.2.3
#global prerel rc1
%global rpmrel 2

Name:		bluefish
Version:	%{pkgver}
Release:	%{?prerel:0.}%{rpmrel}%{?prerel:.%{prerel}}%{?dist}
Summary:	GTK2 web development application for experienced users
Group:		Development/Tools
License:	GPLv3+
URL:		http://bluefish.openoffice.nl/
Source0:	http://www.bennewitz.com/bluefish/stable/source/bluefish-%{version}%{?prerel:-%{prerel}}.tar.bz2
Patch0:		bluefish-2.2.3-desktop-es.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	desktop-file-utils
BuildRequires:	enchant-devel >= 1.4.2
BuildRequires:	gettext
BuildRequires:	glib2-devel >= 2.18
%if 0%{?fedora} < 15
BuildRequires:	gtk2-devel >= 2.18
BuildRequires:	gucharmap-devel >= 2.20
%else
BuildRequires:	gtk3-devel
BuildRequires:	gucharmap-devel >= 2.90
%endif
BuildRequires:	intltool
BuildRequires:	libxml2-devel
BuildRequires:	python2-devel
# Needed to check man pages
BuildRequires:	/usr/bin/man
# For the Advanced Open function
Requires:	findutils, grep
Requires:	%{name}-shared-data = %{version}-%{release}

# Automatically upgrade bluefish-unstable
Obsoletes:	bluefish-unstable < %{version}-%{release}
Provides:	bluefish-unstable = %{version}-%{release}

# XML Catalog registration
Requires(post): /usr/bin/xmlcatalog, xml-common
Requires(postun): /usr/bin/xmlcatalog, xml-common

# Don't "provide" plugin shared objects
%{?filter_setup:
%filter_provides_in %{_libdir}/%{name}/.*\.so$
%filter_setup
}

%description
Bluefish is a powerful editor for experienced web designers and programmers.
Bluefish supports many programming and markup languages, but it focuses on
editing dynamic and interactive websites.

%package shared-data
Summary:	Architecture-independent data for %{name}
Group:		Development/Tools
BuildArch:	noarch
# For ownership of %%{_datadir}/mime/packages
Requires:	shared-mime-info
# For ownership of %%{_datadir}/icons/hicolor/*/{apps,mimetypes}
Requires:	hicolor-icon-theme

# Automatically upgrade bluefish-unstable-shared-data
Obsoletes:	bluefish-unstable-shared-data < %{version}-%{release}
Provides:	bluefish-unstable-shared-data = %{version}-%{release}

%description shared-data
Files common to every architecture version of %{name}.

%prep
%setup -q -n %{name}-%{version}%{?prerel:-%{prerel}}

# Fix missing trailing semicolon in Spanish translation of desktop file
# Gnome Bug #678951
%patch0

%build
%configure	--disable-dependency-tracking \
		--disable-static \
		--disable-update-databases \
		--disable-xml-catalog-update \
		--docdir=%{_defaultdocdir}/%{name}-%{version}
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_datadir}/applications
make install DESTDIR=%{buildroot} INSTALL="install -p"

# Make zencoding plugin scripts executable to placate rpmlint
find %{buildroot}%{_datadir}/bluefish/plugins/zencoding -name '*.py' |
	xargs awk '/^#!/ { print FILENAME }' |
	xargs chmod -c +x

%find_lang %{name}
%find_lang %{name}_plugin_about
%find_lang %{name}_plugin_charmap
%find_lang %{name}_plugin_entities
%find_lang %{name}_plugin_htmlbar
%find_lang %{name}_plugin_infbrowser
%find_lang %{name}_plugin_snippets
%find_lang %{name}_plugin_zencoding
cat %{name}_plugin_{about,charmap,entities,htmlbar,infbrowser,snippets,zencoding}.lang >> \
	%{name}.lang

desktop-file-validate \
	%{buildroot}%{_datadir}/applications/%{name}.desktop

# Manually install docs so that they go into
# %%{_defaultdocdir}/%%{name}-%%{version} even though we put them in the
# shared-data subpackage
install -m 644 -p -t %{buildroot}%{_defaultdocdir}/%{name}-%{version}/ \
	AUTHORS ChangeLog COPYING NEWS README TODO

# Unpackaged files
rm -f %{buildroot}%{_libdir}/%{name}/*.la

%clean
rm -rf %{buildroot}

%post
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :
/usr/bin/update-desktop-database &> /dev/null || :
/usr/bin/xmlcatalog --noout --add 'delegateURI' \
	'http://bluefish.openoffice.nl/ns/bflang/2.0/' \
	'%{_datadir}/xml/%{name}' \
	%{_sysconfdir}/xml/catalog &> /dev/null || :

%postun
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :
/usr/bin/update-desktop-database &> /dev/null || :
if [ "$1" = 0 ]; then
	/usr/bin/xmlcatalog --noout --del \
		'http://bluefish.openoffice.nl/ns/bflang/2.0/' \
		%{_sysconfdir}/xml/catalog &> /dev/null || :
fi

%files
%defattr(-,root,root,-)
%{_bindir}/%{name}
%{_libdir}/%{name}/

%files shared-data -f %{name}.lang
%defattr(-,root,root,-)
%{_datadir}/%{name}/
%{_datadir}/applications/%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/icons/hicolor/*/mimetypes/application-x-bluefish-project.png
%{_datadir}/icons/hicolor/*/apps/%{name}.png
%{_datadir}/icons/hicolor/scalable/mimetypes/bluefish-project.svg
%{_datadir}/icons/hicolor/scalable/apps/bluefish-icon.svg
%{_datadir}/pixmaps/application-x-bluefish-project.png
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/xml/%{name}/
%{_defaultdocdir}/%{name}-%{version}/
%{_mandir}/man1/%{name}.1*

%changelog
* Thu Jul 19 2012 Paul Howarth <paul@city-fan.org> - 2.2.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Jun 27 2012 Paul Howarth <paul@city-fan.org> - 2.2.3-1
- Update to 2.2.3 (many minor bugfixes and many minor enhancements)
  - Fix segfault in syntax scanner
  - Code folding has major fixes and improvements
  - Search has major fixes
  - Lorem ipsum generator added
  - GUI restructured in some areas
  - Some shortcut key combinations added
  - Visibility features such as bigger cursor and cursor highlighting added,
    and some options were improved such as zoom and custom colors
  - Changes to external commands include better cursor positioning after a
    filter has been used, user-supplied arguments, and an option to restore
    the default settings
  - Some dialogs added for HTML5
  - Thumbnail generator fixed
  - Insert color, path and relative path have been added
  - Many language files improved, and more user configurable options added to
    most language files
  - You can now select a block of text by dragging the mouse in the margin, and
    move the selected block with <ctrl><up> and <ctrl><down>
- Drop workaround for broken gucharmap pkgconfig file (#795537)
- Fix missing trailing semicolon in Spanish translation of desktop file
  (Gnome Bug #678951)
- Bump gtk2 requirement to 2.18 (F-12 and above) (Gnome Bug #678953)

* Wed Feb 29 2012 Paul Howarth <paul@city-fan.org> - 2.2.2-1
- Update to 2.2.2 (bug fix release with some very minor new features)
  - Fix segfault when closing document with active search results
  - Fix multiple replace with search results directly adjacent corrupting text
  - Fix broken cursor positioning that ruined the Zencoding plugin
  - Fix CSS dialog that was unusable on GTK-3
  - Fix position of right margin indicator on GTK-3
  - Fix several small memory leaks
  - Fix annoying scrolling of the side bar filebrowser in 'treeview' mode
  - Use multiple threads to improve start-up performance
  - Fix descriptions of language options
  - Improve HTML5 option text and menu strings
  - Improve accelerators, shortcut keys and translations
  - New features: duplicate line and delete line
  - Add Catalan translation
- Fix permissions of zencoding plugin scripts to placate rpmlint

* Mon Feb 27 2012 Paul Howarth <paul@city-fan.org> - 2.2.2-0.1.rc1
- Update to 2.2.2-rc1
- Drop upstream patch for #771227
- BR: glib2 ≥ 2.18 (Gnome Bug #670883)
- Drop support for F-9, which doesn't have glib2 ≥ 2.18

* Mon Feb 20 2012 Paul Howarth <paul@city-fan.org> - 2.2.1-3
- Fix abort due to free() of invalid pointer (#771227)
- Work around broken gucharmap pkgconfig file (#795537)

* Thu Jan  5 2012 Paul Howarth <paul@city-fan.org> - 2.2.1-2
- Rebuild for gcc 4.7

* Fri Dec 23 2011 Paul Howarth <paul@city-fan.org> - 2.2.1-1
- Update to 2.2.1
  - New feature: Zencoding support
  - Fix to build on Gtk+-2.22
  - Fix for PCRE regular expression searching
  - Layout fixes for Gtk+-3.2
  - Several obscure segfault fixes
  - Fix for autocompletion of variables in PHP
  - <img> dialog fixes
  - Memory-leak fixes
- Drop patch, now included upstream
- BR: python2-devel

* Tue Nov 22 2011 Paul Howarth <paul@city-fan.org> - 2.2.0-1
- Update to 2.2.0
  - New "select block" feature
  - Block stack is displayed on the statusbar
  - Completely rewritten search and replace engine
  - Quickbar feature has been removed
  - Large changes internally for GTK3 compatibility
- Drop patches, now included upstream
- Add patch to fix build with gtk 2.22 (Gnome bug 664556)

* Fri Jul 22 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-4
- Fix crash in _gtk_text_btree_get_chars_changed_stamp
  (Gnome bug 654838, #720990)
- Nobody else likes macros for commands

* Thu Mar 10 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-3
- Add workaround for crash on close (Gnome bug 637990, #683497)

* Sun Feb 27 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-2
- Fix highlighting of block delimiters (Gnome bugs 643150 and 643153, #680626)

* Wed Feb 23 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-1
- Update to 2.0.3
- Drop gtk2 version requirement back down to 2.12
- Re-conditionalize shared-data package now that builds with Fedora 9 are
  possible again
- Explicitly BR: GConf2-devel, missing dependency of gucharmap-devel prior to
  Fedora 11

* Mon Feb  7 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-0.2.rc2
- Update to 2.0.3-rc2
- Drop GSEAL_ENABLE removal patch, no longer needed

* Tue Jan  4 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-0.1.rc1
- Update to 2.0.3-rc1
- Drop patches now integrated into upstream release
- Add patch to remove GSEAL_ENABLE define, which breaks builds on Fedora < 12
- Bump gtk2 version requirement to 2.14
- Always build shared-data package now that builds with Fedora < 10 are no
  longer possible

* Sun Dec 19 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-6
- Update patch for #663014 to fix another potential issue that was discovered

* Wed Dec 15 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-5
- Fix crash in autosave (#663014)

* Thu Nov 18 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-4
- Fix crash when removing files/projects from recently-used lists (#653299)

* Thu Oct  7 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-3
- Drop charmap plugin from Rawhide for now

* Thu Sep 30 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-2
- Rebuilt for gcc bug (#634757)

* Fri Sep 17 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-1
- Update to 2.0.2 (minor bugfix and minor feature enhancement release)
  - Two crashes have been resolved
  - A "jump to reference" feature has been added
  - Translations improved

* Tue Sep  7 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-0.1.rc1
- Update to 2.0.2-rc1
- Drop patch for #626246, no longer needed
- License changed from GPLv2+ to GPLv3+

* Thu Aug 26 2010 Paul Howarth <paul@city-fan.org> - 2.0.1-2
- Fix crash in File Open dialog with filter applied (#626246)
- Change buildreq "man" to "/usr/bin/man" since the "man" package has been
  obsoleted by "man-db" from Fedora 14

* Fri Jun 18 2010 Paul Howarth <paul@city-fan.org> - 2.0.1-1
- Update to 2.0.1

* Tue Jun  8 2010 Paul Howarth <paul@city-fan.org> - 2.0.1-0.1.rc1
- Update to 2.0.1-rc1
- Drop upstreamed log10 linking patch
- RHEL-6 onwards have noarch subpackages
- Drop redundant buildreq pcre-devel

* Wed Feb 17 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-2
- Bluefish uses GIO rather than GnomeVFS so buildreq libgnomeui-devel is
  no longer needed
- Explicitly buildreq libxml2-devel

* Tue Feb 16 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-1
- 2.0.0 release
- Remove upstreamed projects patch
- Update log10 linking patch

* Mon Feb 15 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.6.rc3
- Fix FTBFS due to missing -lm linking for log10 function (#565197)

* Sun Jan 31 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.5.rc3
- Update to 2.0.0-rc3
- Drop snippets patch
- Add upstream patch resolving some project-related issues (#549552)

* Wed Jan 27 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.4.rc2
- Apply upstream patch to re-enable snippets menu

* Tue Jan 26 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.3.rc2
- Update to 2.0.0-rc2
- Disable python plugin on upstream advice (#549552 comment 6)
- Disable dependency tracking to speed up build
- Register XML catalog in %%post and %%postun

* Wed Dec 30 2009 Paul Howarth <paul@city-fan.org> - 2.0.0-0.2.rc1
- Reduce indentation of header tags by one tab stop as per Fedora version
- Enable python plugin (disabled by default despite documentation saying not)
- Buildreq enchant-devel >= 1.4.2, needed for enchant_dict_add

* Wed Dec 23 2009 Paul Howarth <paul@city-fan.org> - 2.0.0-0.1.rc1
- Update to 2.0.0-rc1
- Rename package back to bluefish for 2.0.0 release candidates, and add
  provides/obsoletes for bluefish-unstable for upgrade path
- Drop note about this being a development version from %%description
- Use Fedora filter macros for provides filtering

* Mon Nov  9 2009 Paul Howarth <paul@city-fan.org> - 1.3.8-1
- Update to 1.3.8

* Mon Sep 21 2009 Paul Howarth <paul@city-fan.org> - 1.3.7-1
- Update to 1.3.7

* Mon Aug 17 2009 Paul Howarth <paul@city-fan.org> - 1.3.6-1
- Update to 1.3.6
- Switch spell-checking from aspell to enchant
- New charmap plugin now has translations

* Thu Jun 11 2009 Paul Howarth <paul@city-fan.org> - 1.3.5-1
- Update to 1.3.5

* Fri Apr 17 2009 Paul Howarth <paul@city-fan.org> - 1.3.4-1
- Update to 1.3.4
- bluefish-unstable-project.desktop no longer installed

* Mon Mar  2 2009 Paul Howarth <paul@city-fan.org> - 1.3.3-1
- Update to 1.3.3
- Add buildreq gucharmap-devel for new charmap plugin
- Filter out bogus provides for plugins

* Thu Feb 26 2009 Paul Howarth <paul@city-fan.org> - 1.3.2-2
- Split off shared-data noarch subpackage for Fedora 10 onwards
- Upstream no longer includes anything under %%{_datadir}/xml, so we no longer
  need a dependency on xml-common, nor the scriptlet calls to xmlcatalog

* Wed Jan 28 2009 Paul Howarth <paul@city-fan.org> - 1.3.2-1
- Update to 1.3.2
- Project pixmap renamed upstream, so no need to rename it here to avoid
  conflict with current bluefish (stable)
- Mimetype PNGs renamed upstream
- Drop fedora vendor tag for desktop files and use desktop-file-validate
  instead of desktop-file-install with upstream desktop files
- %%{_datadir}/mime-info/%%{name}.{keys,mime} no longer included from upstream

* Mon Jan  5 2009 Paul Howarth <paul@city-fan.org> - 1.3.1-1
- Update to 1.3.1

* Mon Dec 15 2008 Paul Howarth <paul@city-fan.org> - 1.3.0-1
- Update to 1.3.0
- No longer need gnome-vfs2-devel buildreq
- Add buildreq intltool
- Bump version requirement for gtk2-devel to 2.12
- Buildreq glib2-devel >= 2.16

* Fri Mar 28 2008 Paul Howarth <paul@city-fan.org> - 1.1.6-1
- Update to 1.1.6

* Thu Nov 22 2007 Paul Howarth <paul@city-fan.org> - 1.1.5-1
- First RPM package, intended to be parallel-installable with bluefish,
  based in part on Matthias Haase's package
